#pragma once

#define MAX_FRAC 8

enum { VX, VY, VZ, VW };

class zVEC2
{
public:
	zREAL n[2];

public:
	zVEC2() { }
	zVEC2(const zREAL f) { n[VX] = f; n[VY] = f; }
	zVEC2(const zREAL x, const zREAL y) { n[VX] = x; n[VY] = y; }

	zREAL &operator [](const zINT i) { return n[i]; }
	zREAL operator [](const zINT i) const { return n[i]; }

	zVOID SetByDescription(zSTRING &desc) { n[VX] = desc.PickWorld_Old(1, zSTR_EMPTY).ToFloat(); n[VY] = desc.PickWorld_Old(2, zSTR_EMPTY).ToFloat(); }
	zSTRING GetDescription() const { zSTRING s; zSTRING s1(n[0], MAX_FRAC); zSTRING s2(" "); zSTRING s3(n[1], MAX_FRAC); s += s1 + s2 + s3; return s; }
};

class zVEC3
{
public:
	zREAL n[3];

public:
	zVEC3() { }
	zVEC3(const zREAL f) { n[VX] = f; n[VY] = f; n[VZ] = f; }
	zVEC3(const zREAL x, const zREAL y, const zREAL z) { n[VX] = x; n[VY] = y; n[VZ] = z; }

	zREAL &operator [](const zINT i) { return n[i]; }
	zREAL operator [](const zINT i) const { return n[i]; }
	friend zBOOL operator ==(const zVEC3 &a, const zVEC3 &b) { return (a[VX] == b[VX]) && (a[VY] == b[VY]) && (a[VZ] == b[VZ]); }
	friend zBOOL operator !=(const zVEC3 &a, const zVEC3 &b) { return !(a == b); }
};

typedef zVEC2 zPOINT2;
typedef zVEC3 zPOINT3;
